diff --git a/eos/private/pc_eos.f90 b/eos/private/pc_eos.f90
index 73031183..f9641a13 100644
--- a/eos/private/pc_eos.f90
+++ b/eos/private/pc_eos.f90
@@ -771,244 +589,140 @@
 !           PSCR - pressure divided by (n_i kT) (screen.contrib.)
 !           CVSCR - heat capacity per 1 ion (screen.contrib.)
 !           PDTSCR,PDRSCR = PSCR + d PSCR / d ln(T,\rho)
-      use pc_support
-      type(auto_diff_real_2var_order1), intent(in) :: RS,GAME
-      real(dp), intent(in) :: Zion
-      type(auto_diff_real_2var_order1), intent(out) :: FSCR,USCR,PSCR,CVSCR,PDTSCR,PDRSCR
+      real(dp), intent(in) :: RS,GAME,Zion
+      real(dp), intent(out) :: FSCR,USCR,PSCR,CVSCR,PDTSCR,PDRSCR
       integer, intent(out) :: ierr
 
-      type(auto_diff_real_2var_order1) :: SQG, SQR, SQZ1, SQZ, CDH0, CDH, ZLN, Z13
-      type(auto_diff_real_2var_order1) :: X, CTF, P01, P03, PTX
-      type(auto_diff_real_2var_order1) :: TX, TXDG, TXDGG, TY1, TY1DG, TY1DGG
-      type(auto_diff_real_2var_order1) :: TY2, TY2DX, TY2DXX, TY, TYX, TYDX, TYDG, P1
-      type(auto_diff_real_2var_order1) :: COR1, COR1DX, COR1DG, COR1DXX, COR1DGG, COR1DXG
-      type(auto_diff_real_2var_order1) :: U0, U0DX, U0DG, U0DXX, U0DGG, U0DXG
-      type(auto_diff_real_2var_order1) :: D0DG, D0, D0DX, D0DXX
-      type(auto_diff_real_2var_order1) :: COR0, COR0DX, COR0DG, COR0DXX, COR0DGG, COR0DXG
-      type(auto_diff_real_2var_order1) :: RELE, Q1, Q2, H1U, H1D, H1, H1X, H1DX, H1DXX
-      type(auto_diff_real_2var_order1) :: UP, UPDX, UPDG, UPDXX, UPDGG, UPDXG
-      type(auto_diff_real_2var_order1) :: DN1, DN1DX, DN1DG, DN1DXX, DN1DGG, DN1DXG
-      type(auto_diff_real_2var_order1) :: DN, DNDX, DNDG, DNDXX, DNDGG, DNDXG
-      type(auto_diff_real_2var_order1) :: FX, FXDG, FDX, FG, FDG, FDGDH, FDXX, FDGG, FDXG
+      real(dp) :: SQG, SQR, SQZ1, SQZ, CDH0, CDH, ZLN, Z13
+      real(dp) :: X, CTF, P01, P03, PTX
+      real(dp) :: TX, TXDG, TXDGG, TY1, TY1DG, TY1DGG
+      real(dp) :: TY2, TY2DX, TY2DXX, TY, TYX, TYDX, TYDG, P1
+      real(dp) :: COR1, COR1DX, COR1DG, COR1DXX, COR1DGG, COR1DXG
+      real(dp) :: U0, U0DX, U0DG, U0DXX, U0DGG, U0DXG
+      real(dp) :: D0DG, D0, D0DX, D0DXX
+      real(dp) :: COR0, COR0DX, COR0DG, COR0DXX, COR0DGG, COR0DXG
+      real(dp) :: RELE, Q1, Q2, H1U, H1D, H1, H1X, H1DX, H1DXX
+      real(dp) :: UP, UPDX, UPDG, UPDXX, UPDGG, UPDXG
+      real(dp) :: DN1, DN1DX, DN1DG, DN1DXX, DN1DGG, DN1DXG
+      real(dp) :: DN, DNDX, DNDG, DNDXX, DNDGG, DNDXG
+      real(dp) :: FX, FXDG, FDX, FG, FDG, FDGDH, FDXX, FDGG, FDXG
       
       real(dp), parameter :: XRS=.0140047d0
       real(dp), parameter :: TINY=1.d-19
-      
-      real(dp) :: &
-         xFSCR, dFSCR_dlnRS, dFSCR_dlnGAME, &
-         xUSCR, dUSCR_dlnRS, dUSCR_dlnGAME, &
-         xPSCR, dPSCR_dlnRS, dPSCR_dlnGAME, &
-         xCVSCR, dCVSCR_dlnRS, dCVSCR_dlnGAME, &
-         xPDTSCR, dPDTSCR_dlnRS, dPDTSCR_dlnGAME, &
-         xPDRSCR, dPDRSCR_dlnRS, dPDRSCR_dlnGAME
-      real(dp) :: dlnRs_dT, dlnRs_dRho, dlnGAME_dT, dlnGAME_dRho
-      logical :: skip
-      logical, parameter :: use_FSCRliq8_table = .false.
-      logical, parameter :: debug_FSCRliq8_table = .false.
-
       ierr = 0
-      if (RS.lt.0d0) then
+      if (RS.lt.0.) then
          ierr = -1
          return
          !stop 'FSCRliq8: RS < 0'
       end if
       if (RS.lt.TINY) then
-         FSCR=0.d0
-         USCR=0.d0
-         PSCR=0.d0
-         CVSCR=0.d0
-         PDTSCR=0.d0
-         PDRSCR=0.d0
+         FSCR=0.
+         USCR=0.
+         PSCR=0.
+         CVSCR=0.
+         PDTSCR=0.
+         PDRSCR=0.
          return
       endif
-      
-      if (use_FSCRliq8_table .or. debug_FSCRliq8_table) then
-         ierr = 0
-         call get_FSCRliq8(int(Zion), RS%val, GAME%val, &
-            xFSCR, dFSCR_dlnRS, dFSCR_dlnGAME, &
-            xUSCR, dUSCR_dlnRS, dUSCR_dlnGAME, &
-            xPSCR, dPSCR_dlnRS, dPSCR_dlnGAME, &
-            xCVSCR, dCVSCR_dlnRS, dCVSCR_dlnGAME, &
-            xPDTSCR, dPDTSCR_dlnRS, dPDTSCR_dlnGAME, &
-            xPDRSCR, dPDRSCR_dlnRS, dPDRSCR_dlnGAME, skip, ierr)
-         if (ierr /= 0) return      
-      else
-         skip = .true.
-      endif
-
-      if (.not. use_FSCRliq8_table .or. debug_FSCRliq8_table .or. skip) then
-
-         SQG=sqrt(GAME)
-         SQR=sqrt(RS)
-         SQZ1=sqrt(1d0+Zion)
-         SQZ=sqrt(Zion)
-         CDH0=Zion/1.73205d0 ! 1.73205=sqrt(3.)
-         CDH=CDH0*(SQZ1*SQZ1*SQZ1-SQZ*SQZ*SQZ-1d0)
-         SQG=sqrt(GAME)
-         ZLN=log(Zion)
-         Z13=exp(ZLN/3.d0) ! Zion**(1./3.)
-         X=XRS/RS ! relativity parameter
-         CTF=Zion*Zion*.2513d0*(Z13-1d0+.2d0/sqrt(Z13))
-         ! Thomas-Fermi constant; .2513=(18/175)(12/\pi)^{2/3}
-         P01=1.11d0*exp(0.475d0*ZLN)
-         P03=0.2d0+0.078d0*ZLN*ZLN
-         PTX=1.16d0+0.08d0*ZLN
-         TX=pow(GAME,PTX)
-         TXDG=PTX*TX/GAME
-         TXDGG=(PTX-1.d0)*TXDG/GAME
-         TY1=1d0/(1.d-3*Zion*Zion+2d0*GAME)
-         TY1DG=-2d0*TY1*TY1
-         TY1DGG=-4d0*TY1*TY1DG
-         TY2=1d0+6d0*RS*RS
-         TY2DX=-12d0*RS*RS/X
-         TY2DXX=-3d0*TY2DX/X
-         TY=RS*RS*RS/TY2*(1d0+TY1)
-         TYX=3d0/X+TY2DX/TY2
-         TYDX=-TY*TYX
-         TYDG=RS*RS*RS*TY1DG/TY2
-         P1=(Zion-1d0)/9d0
-         COR1=1d0+P1*TY
-         COR1DX=P1*TYDX
-         COR1DG=P1*TYDG
-         COR1DXX=P1*(TY*(3d0/(X*X)+(TY2DX/TY2)*(TY2DX/TY2)-TY2DXX/TY2)-TYDX*TYX)
-         COR1DGG=P1*RS*RS*RS*TY1DGG/TY2
-         COR1DXG=-P1*TYDG*TYX
-         U0=0.78d0*sqrt(GAME/Zion)*RS*RS*RS
-         U0DX=-3d0*U0/X
-         U0DG=.5d0*U0/GAME
-         U0DXX=-4.d0*U0DX/X
-         U0DGG=-.5d0*U0DG/GAME
-         U0DXG=-3.d0*U0DG/X
-         D0DG=Zion*Zion*Zion
-         D0=GAME*D0DG+21d0*RS*RS*RS
-         D0DX=-63d0*RS*RS*RS/X
-         D0DXX=252d0*RS*RS*RS/(X*X)
-         COR0=1d0+U0/D0
-         COR0DX=(U0DX-U0*D0DX/D0)/D0
-         COR0DG=(U0DG-U0*D0DG/D0)/D0
-         COR0DXX=(U0DXX-(2d0*U0DX*D0DX+U0*D0DXX)/D0+2d0*(D0DX/D0)*(D0DX/D0))/D0
-         COR0DGG=(U0DGG-2d0*U0DG*D0DG/D0+2d0*U0*(D0DG/D0)*(D0DG/D0))/D0
-         COR0DXG=(U0DXG-(U0DX*D0DG+U0DG*D0DX)/D0+2d0*U0*D0DX*D0DG/(D0*D0))/D0
-         ! Relativism:
-         RELE=sqrt(1.d0+X*X)
-         Q1=0.18d0/sqrt(sqrt(Zion))
-         Q2=0.2d0+0.37d0/sqrt(Zion)
-         H1U=1d0+X*X/5.d0
-         H1D=1d0+Q1*X+Q2*X*X
-         H1=H1U/H1D
-         H1X=0.4d0*X/H1U-(Q1+2d0*Q2*X)/H1D
-         H1DX=H1*H1X
-         H1DXX=H1DX*H1X &
-            + H1*(0.4d0/H1U-(0.4d0*X/H1U)*(0.4d0*X/H1U)-2d0*Q2/H1D+pow2((Q1+2d0*Q2*X)/H1D))
-         UP=CDH*SQG+P01*CTF*TX*COR0*H1
-         UPDX=P01*CTF*TX*(COR0DX*H1+COR0*H1DX)
-         UPDG=.5d0*CDH/SQG+P01*CTF*(TXDG*COR0+TX*COR0DG)*H1
-         UPDXX=P01*CTF*TX*(COR0DXX*H1+2d0*COR0DX*H1DX+COR0*H1DXX)
-         UPDGG=-.25d0*CDH/(SQG*GAME) &
-            + P01*CTF*(TXDGG*COR0+2d0*TXDG*COR0DG+TX*COR0DGG)*H1
-         UPDXG=P01*CTF*(TXDG*(COR0DX*H1+COR0*H1DX) &
-            + TX*(COR0DXG*H1+COR0DG*H1DX))
-         DN1=P03*SQG+P01/RS*TX*COR1
-         DN1DX=P01*TX*(COR1/XRS+COR1DX/RS)
-         DN1DG=.5d0*P03/SQG+P01/RS*(TXDG*COR1+TX*COR1DG)
-         DN1DXX=P01*TX/XRS*(2d0*COR1DX+X*COR1DXX)
-         DN1DGG=-.25d0*P03/(GAME*SQG) &
-            + P01/RS*(TXDGG*COR1+2d0*TXDG*COR1DG+TX*COR1DGG)
-         DN1DXG=P01*(TXDG*(COR1/XRS+COR1DX/RS)+TX*(COR1DG/XRS+COR1DXG/RS))
-         DN=1d0+DN1/RELE
-         DNDX=DN1DX/RELE-X*DN1/(RELE*RELE*RELE)
-         DNDXX=(DN1DXX-((2d0*X*DN1DX+DN1)-3.d0*X*X*DN1/(RELE*RELE))/(RELE*RELE))/RELE
-         DNDG=DN1DG/RELE
-         DNDGG=DN1DGG/RELE
-         DNDXG=DN1DXG/RELE-X*DN1DG/(RELE*RELE*RELE)
-         FSCR=-UP/DN*GAME
-         FX=(UP*DNDX/DN-UPDX)/DN
-         FXDG=((UPDG*DNDX+UPDX*DNDG+UP*DNDXG-2d0*UP*DNDX*DNDG/DN)/DN-UPDXG)/DN
-         FDX=FX*GAME
-         FG=(UP*DNDG/DN-UPDG)/DN
-         FDG=FG*GAME-UP/DN
-         FDGDH=SQG*DNDG/(DN*DN) ! d FDG / d CDH
-         FDXX=((UP*DNDXX+2d0*(UPDX*DNDX-UP*DNDX*DNDX/DN))/DN-UPDXX)/DN*GAME
-         FDGG=2d0*FG+GAME*((2d0*DNDG*(UPDG-UP*DNDG/DN)+UP*DNDGG)/DN-UPDGG)/DN
-         FDXG=FX+GAME*FXDG
-         USCR=GAME*FDG
-         CVSCR=-GAME*GAME*FDGG
-         PSCR=(X*FDX+GAME*FDG)/3.d0
-         PDTSCR=-GAME*GAME*(X*FXDG+FDGG)/3.d0
-         PDRSCR=(12d0*PSCR+X*X*FDXX+2d0*X*GAME*FDXG+GAME*GAME*FDGG)/9d0
-
-      endif
-
-      if (debug_FSCRliq8_table .and. .not. skip) then
-
-         if (.not. check1(FSCR, xFSCR, 'FSCR')) return
-         if (.not. check1(USCR, xUSCR, 'USCR')) return
-         if (.not. check1(PSCR, xPSCR, 'PSCR')) return
-         if (.not. check1(CVSCR, xCVSCR, 'CVSCR')) return
-         if (.not. check1(PDTSCR, xPDTSCR, 'PDTSCR')) return
-         if (.not. check1(PDRSCR, xPDRSCR, 'PDRSCR')) return
-
-      endif
-
-      if (use_FSCRliq8_table .and. .not. skip) then
-
-         ! values
-         FSCR% val = xFSCR
-         USCR% val = xUSCR
-         PSCR% val = xPSCR
-         CVSCR% val = xCVSCR
-         PDTSCR% val = xPDTSCR
-         PDRSCR% val = xPDRSCR
-
-         ! dT (val1) derivatives
-         ! dlnRs_dT = RS% d1val1 / RS% val = 0
-         dlnGAME_dT = GAME% d1val1 / GAME% val
-
-         FSCR% d1val1 = dFSCR_dlnGAME * dlnGAME_dT
-         USCR% d1val1 = dUSCR_dlnGAME * dlnGAME_dT
-         PSCR% d1val1 = dPSCR_dlnGAME * dlnGAME_dT
-         CVSCR% d1val1 = dCVSCR_dlnGAME * dlnGAME_dT
-         PDTSCR% d1val1 = dPDTSCR_dlnGAME * dlnGAME_dT
-         PDRSCR% d1val1 = dPDRSCR_dlnGAME * dlnGAME_dT
-
-         ! dRho (val2) derivatives
-         dlnRs_dRho = RS% d1val2 / RS% val
-         dlnGAME_dRho = GAME% d1val2 / GAME% val
-
-         FSCR% d1val2 = dFSCR_dlnRS * dlnRS_dRho + dFSCR_dlnGAME * dlnGAME_dRho
-         USCR% d1val2 = dUSCR_dlnRS * dlnRS_dRho + dUSCR_dlnGAME * dlnGAME_dRho
-         PSCR% d1val2 = dPSCR_dlnRS * dlnRS_dRho + dPSCR_dlnGAME * dlnGAME_dRho
-         CVSCR% d1val2 = dCVSCR_dlnRS * dlnRS_dRho + dCVSCR_dlnGAME * dlnGAME_dRho
-         PDTSCR% d1val2 = dPDTSCR_dlnRS * dlnRS_dRho + dPDTSCR_dlnGAME * dlnGAME_dRho
-         PDRSCR% d1val2 = dPDRSCR_dlnRS * dlnRS_dRho + dPDRSCR_dlnGAME * dlnGAME_dRho
-         
-      end if
-
-      contains
-
-      logical function check1(v, xv, str)
-         type(auto_diff_real_2var_order1), intent(in) :: v
-         real(dp), intent(in) :: xv
-         character (len=*), intent(in) :: str
-         real(dp) :: val
-         real(dp), parameter :: atol = 1d-8, rtol = 1d-6
-         include 'formats'
-         val = v%val
-         check1 = .false.
-         if (is_bad(xv)) then
-            write(*,*) 'is_bad ' // trim(str), xv, val, int(Zion), RS, GAME
-            return
-         end if
-         if (abs(val - xv) > atol + rtol*max(abs(val),abs(xv))) then
-            write(*,*) 'rel mismatch ' // trim(str), &
-               (val - xv)/max(abs(val),abs(xv),1d-99), &
-               xv, val, int(Zion), RS%val, GAME%val
-            stop 'FSCRliq8'
-            return
-         end if
-         check1 = .true.
-      end function check1
-
+      SQG=sqrt(GAME)
+      SQR=sqrt(RS)
+      SQZ1=dsqrt(1.+Zion)
+      SQZ=dsqrt(Zion)
+      CDH0=Zion/1.73205d0 ! 1.73205=sqrt(3.)
+      CDH=CDH0*(SQZ1*SQZ1*SQZ1-SQZ*SQZ*SQZ-1.)
+      SQG=sqrt(GAME)
+      ZLN=log(Zion)
+      Z13=exp(ZLN/3.) ! Zion**(1./3.)
+      X=XRS/RS ! relativity parameter
+      CTF=Zion*Zion*.2513d0*(Z13-1.+.2/sqrt(Z13))
+! Thomas-Fermi constant; .2513=(18/175)(12/\pi)^{2/3}
+      P01=1.11d0*exp(0.475d0*ZLN)
+      P03=0.2d0+0.078d0*ZLN*ZLN
+      PTX=1.16d0+0.08d0*ZLN
+      TX=pow(GAME,PTX)
+      TXDG=PTX*TX/GAME
+      TXDGG=(PTX-1.)*TXDG/GAME
+      TY1=1./(1.d-3*Zion*Zion+2.*GAME)
+      TY1DG=-2.*TY1*TY1
+      TY1DGG=-4.*TY1*TY1DG
+      TY2=1.+6.*RS*RS
+      TY2DX=-12.*RS*RS/X
+      TY2DXX=-3.*TY2DX/X
+      TY=RS*RS*RS/TY2*(1.+TY1)
+      TYX=3./X+TY2DX/TY2
+      TYDX=-TY*TYX
+      TYDG=RS*RS*RS*TY1DG/TY2
+      P1=(Zion-1.)/9.
+      COR1=1.+P1*TY
+      COR1DX=P1*TYDX
+      COR1DG=P1*TYDG
+      COR1DXX=P1*(TY*(3./(X*X)+(TY2DX/TY2)*(TY2DX/TY2)-TY2DXX/TY2)-TYDX*TYX)
+      COR1DGG=P1*RS*RS*RS*TY1DGG/TY2
+      COR1DXG=-P1*TYDG*TYX
+      U0=0.78d0*sqrt(GAME/Zion)*RS*RS*RS
+      U0DX=-3d0*U0/X
+      U0DG=.5d0*U0/GAME
+      U0DXX=-4.d0*U0DX/X
+      U0DGG=-.5d0*U0DG/GAME
+      U0DXG=-3.d0*U0DG/X
+      D0DG=Zion*Zion*Zion
+      D0=GAME*D0DG+21.*RS*RS*RS
+      D0DX=-63.*RS*RS*RS/X
+      D0DXX=252.*RS*RS*RS/(X*X)
+      COR0=1.+U0/D0
+      COR0DX=(U0DX-U0*D0DX/D0)/D0
+      COR0DG=(U0DG-U0*D0DG/D0)/D0
+      COR0DXX=(U0DXX-(2.*U0DX*D0DX+U0*D0DXX)/D0+2.*(D0DX/D0)*(D0DX/D0))/D0
+      COR0DGG=(U0DGG-2.*U0DG*D0DG/D0+2.*U0*(D0DG/D0)*(D0DG/D0))/D0
+      COR0DXG=(U0DXG-(U0DX*D0DG+U0DG*D0DX)/D0+2.*U0*D0DX*D0DG/(D0*D0))/D0
+! Relativism:
+      RELE=dsqrt(1.d0+X*X)
+      Q1=0.18d0/dsqrt(dsqrt(Zion))
+      Q2=0.2d0+0.37d0/dsqrt(Zion)
+      H1U=1.+X*X/5.
+      H1D=1.+Q1*X+Q2*X*X
+      H1=H1U/H1D
+      H1X=0.4d0*X/H1U-(Q1+2.*Q2*X)/H1D
+      H1DX=H1*H1X
+      H1DXX=H1DX*H1X &
+         + H1*(0.4d0/H1U-(0.4d0*X/H1U)*(0.4d0*X/H1U)-2.*Q2/H1D+pow2((Q1+2.*Q2*X)/H1D))
+      UP=CDH*SQG+P01*CTF*TX*COR0*H1
+      UPDX=P01*CTF*TX*(COR0DX*H1+COR0*H1DX)
+      UPDG=.5d0*CDH/SQG+P01*CTF*(TXDG*COR0+TX*COR0DG)*H1
+      UPDXX=P01*CTF*TX*(COR0DXX*H1+2.*COR0DX*H1DX+COR0*H1DXX)
+      UPDGG=-.25d0*CDH/(SQG*GAME) &
+         + P01*CTF*(TXDGG*COR0+2.*TXDG*COR0DG+TX*COR0DGG)*H1
+      UPDXG=P01*CTF*(TXDG*(COR0DX*H1+COR0*H1DX) &
+        + TX*(COR0DXG*H1+COR0DG*H1DX))
+      DN1=P03*SQG+P01/RS*TX*COR1
+      DN1DX=P01*TX*(COR1/XRS+COR1DX/RS)
+      DN1DG=.5d0*P03/SQG+P01/RS*(TXDG*COR1+TX*COR1DG)
+      DN1DXX=P01*TX/XRS*(2.*COR1DX+X*COR1DXX)
+      DN1DGG=-.25d0*P03/(GAME*SQG) &
+         + P01/RS*(TXDGG*COR1+2.*TXDG*COR1DG+TX*COR1DGG)
+      DN1DXG=P01*(TXDG*(COR1/XRS+COR1DX/RS)+TX*(COR1DG/XRS+COR1DXG/RS))
+      DN=1.+DN1/RELE
+      DNDX=DN1DX/RELE-X*DN1/(RELE*RELE*RELE)
+      DNDXX=(DN1DXX-((2.*X*DN1DX+DN1)-3.*X*X*DN1/(RELE*RELE))/(RELE*RELE))/RELE
+      DNDG=DN1DG/RELE
+      DNDGG=DN1DGG/RELE
+      DNDXG=DN1DXG/RELE-X*DN1DG/(RELE*RELE*RELE)
+      FSCR=-UP/DN*GAME
+      FX=(UP*DNDX/DN-UPDX)/DN
+      FXDG=((UPDG*DNDX+UPDX*DNDG+UP*DNDXG-2.*UP*DNDX*DNDG/DN)/DN-UPDXG)/DN
+      FDX=FX*GAME
+      FG=(UP*DNDG/DN-UPDG)/DN
+      FDG=FG*GAME-UP/DN
+      FDGDH=SQG*DNDG/(DN*DN) ! d FDG / d CDH
+      FDXX=((UP*DNDXX+2.*(UPDX*DNDX-UP*DNDX*DNDX/DN))/DN-UPDXX)/DN*GAME
+      FDGG=2.*FG+GAME*((2.*DNDG*(UPDG-UP*DNDG/DN)+UP*DNDGG)/DN-UPDGG)/DN
+      FDXG=FX+GAME*FXDG
+      USCR=GAME*FDG
+      CVSCR=-GAME*GAME*FDGG
+      PSCR=(X*FDX+GAME*FDG)/3.
+      PDTSCR=-GAME*GAME*(X*FXDG+FDGG)/3.
+      PDRSCR=(12.*PSCR+X*X*FDXX+2.*X*GAME*FDXG+GAME*GAME*FDGG)/9.
+      return
       end subroutine FSCRliq8
 
 ! ==============   SUBROUTINES FOR THE SOLID STATE   ================= *
@@ -1016,7 +730,6 @@
            FSCR,USCR,PSCR,S_SCR,CVSCR,PDTSCR,PDRSCR,ierr)
 !                                                       Version 28.05.08
 !                    undefined zero variable Q1DXG is wiped out 21.06.10
-!                                               cosmetic change 16.05.13
 ! Fit to the el.-ion screening in bcc or fcc Coulomb solid
 ! Stems from FSCRsol8 v.09.06.07. Included a check for RS=0.
 !   INPUT: RS - el. density parameter, GAMI - ion coupling parameter,
@@ -1027,83 +740,69 @@
 !           S_SCR - screening entropy contribution / (N_i k)
 !           CVSCR - heat capacity per 1 ion (screen.contrib.)
 !           PDTSCR,PDRSCR = PSCR + d PSCR / d ln(T,\rho)
-      type(auto_diff_real_2var_order1), intent(in) :: RS,GAMI
-      real(dp), intent(in) :: Zion
-      type(auto_diff_real_2var_order1) :: TPT
-      type(auto_diff_real_2var_order1), intent(out) :: FSCR,USCR,PSCR,S_SCR,CVSCR,PDTSCR,PDRSCR
+      real(dp), intent(in) :: RS,GAMI,Zion,TPT
+      real(dp), intent(out) :: FSCR,USCR,PSCR,S_SCR,CVSCR,PDTSCR,PDRSCR
       integer, intent(out) :: ierr
 
-      type(auto_diff_real_2var_order1) :: XSR, P1, P2, Finf, FinfX, FinfDX, FinfDXX
-      real(dp) :: Z13, ZLN, R1, R2, R3
-      type(auto_diff_real_2var_order1) :: Q1U, Q1D, Q1, Q1X, Q1XDX, Q1DX, Q1DXX
-      type(auto_diff_real_2var_order1) :: Y0, Y0DX, Y0DG, Y0DXX, Y0DGG, Y0DXG
-      type(auto_diff_real_2var_order1) :: Y1, Y1DX, Y1DG, Y1DXX, Y1DGG, Y1DXG
-      type(auto_diff_real_2var_order1) :: SA, SUPA, SUPADX, SUPADG, SUPADXX, SUPADGG, SUPADXG
-      type(auto_diff_real_2var_order1) :: EM2, EM2Y1
-      type(auto_diff_real_2var_order1) :: SB, SUPB, SUPBDX, SUPBDG, SUPBDXX, SUPBDGG, SUPBDXG
-      type(auto_diff_real_2var_order1) :: SUP, SUPX, SUPDX, SUPG, SUPDG, SUPDXX, SUPDGG, SUPDXG
-      type(auto_diff_real_2var_order1) :: GR3, GR3X, GR3DX, GR3G, GR3DG, GR3DXX, GR3DGG, GR3DXG
-      type(auto_diff_real_2var_order1) :: W, WDX, WDG, WDXX, WDGG, WDXG
-      type(auto_diff_real_2var_order1) :: FDX, FDG, FDXX, FDGG, FDXG
+      real(dp) :: XSR, Z13, P1, P2, ZLN, Finf, FinfX, FinfDX, FinfDXX
+      real(dp) :: R1, R2, R3, Q1U, Q1D, Q1, Q1X, Q1XDX, Q1DX, Q1DXX
+      real(dp) :: Y0, Y0DX, Y0DG, Y0DXX, Y0DGG, Y0DXG
+      real(dp) :: Y1, Y1DX, Y1DG, Y1DXX, Y1DGG, Y1DXG
+      real(dp) :: SA, SUPA, SUPADX, SUPADG, SUPADXX, SUPADGG, SUPADXG
+      real(dp) :: EM2, EM2Y1
+      real(dp) :: SB, SUPB, SUPBDX, SUPBDG, SUPBDXX, SUPBDGG, SUPBDXG
+      real(dp) :: SUP, SUPX, SUPDX, SUPG, SUPDG, SUPDXX, SUPDGG, SUPDXG
+      real(dp) :: GR3, GR3X, GR3DX, GR3G, GR3DG, GR3DXX, GR3DGG, GR3DXG
+      real(dp) :: W, WDX, WDG, WDXX, WDGG, WDXG
+      real(dp) :: FDX, FDG, FDXX, FDGG, FDXG
       
-      real(dp) :: AP(4)
-      real(dp) :: ENAT
-      real(dp) :: TINY
-      real(dp) :: PX
-
-
-      AP(1) = 1.1866d0
-      AP(2) = 0.684d0
-      AP(3) = 17.9d0
-      AP(4) = 41.5d0
-
-      ENAT=2.7182818285d0
-      TINY=1.d-19
-      PX=0.205d0
-
+      real(dp), parameter :: AP(4) =  (/1.1866d0,0.684d0,17.9d0,41.5d0/)
+      real(dp), parameter :: ENAT=2.7182818285d0
+      real(dp), parameter :: TINY=1.d-19
+      real(dp), parameter :: PX=0.205d0
 !      data AP/1.1857,.663,17.1,40./,PX/.212/ ! for fcc lattice
       ierr = 0
-      if (RS.lt.0d0) then
+      if (RS.lt.0.) then
          ierr = -1
          return
          !stop 'FSCRsol8: RS < 0'
       end if
       if (RS.lt.TINY) then
-         FSCR=0.d0
-         USCR=0.d0
-         PSCR=0.d0
-         S_SCR=0.d0
-         CVSCR=0.d0
-         PDTSCR=0.d0
-         PDRSCR=0.d0
+         FSCR=0.
+         USCR=0.
+         PSCR=0.
+         S_SCR=0.
+         CVSCR=0.
+         PDTSCR=0.
+         PDRSCR=0.
          return
       endif
       XSR=0.0140047d0/RS ! relativity parameter
       Z13=pow(Zion,1d0/3d0)
-      P1=0.00352d0*(1d0-AP(1)/pow(Zion,0.267d0)+0.27d0/Zion)
-      P2=1d0+2.25d0/Z13* &
-           (1d0+AP(2)*pow5(Zion)+0.222d0*pow6(Zion))/(1d0+0.222d0*pow6(Zion))
+      P1=0.00352d0*(1.-AP(1)/pow(Zion,0.267d0)+0.27d0/Zion)
+      P2=1.+2.25d0/Z13* &
+           (1.+AP(2)*pow5(Zion)+0.222d0*pow6(Zion))/(1.+0.222d0*pow6(Zion))
       ZLN=log(Zion)
-      Finf=sqrt(P2/(XSR*XSR)+1d0)*Z13*Z13*P1 ! The TF limit
+      Finf=sqrt(P2/(XSR*XSR)+1.)*Z13*Z13*P1 ! The TF limit
       FinfX=-P2/((P2+XSR*XSR)*XSR)
       FinfDX=Finf*FinfX
-      FinfDXX=FinfDX*FinfX-FinfDX*(P2+3d0*XSR*XSR)/((P2+XSR*XSR)*XSR)
-      R1=AP(4)/(1d0+ZLN)
+      FinfDXX=FinfDX*FinfX-FinfDX*(P2+3.*XSR*XSR)/((P2+XSR*XSR)*XSR)
+      R1=AP(4)/(1.+ZLN)
       R2=0.395d0*ZLN+0.347d0/Zion/sqrt(Zion)
-      R3=1d0/(1d0+ZLN*sqrt(ZLN)*0.01d0+0.097d0/(Zion*Zion))
+      R3=1./(1.+ZLN*sqrt(ZLN)*0.01d0+0.097d0/(Zion*Zion))
       Q1U=R1+AP(3)*XSR*XSR
-      Q1D=1d0+R2*XSR*XSR
+      Q1D=1.+R2*XSR*XSR
       Q1=Q1U/Q1D
-      Q1X=2d0*XSR*(AP(3)/Q1U-R2/Q1D)
-      Q1XDX=Q1X/XSR+4d0*XSR*XSR*((R2/Q1D)*(R2/Q1D)-(AP(3)/Q1U)*(AP(3)/Q1U))
+      Q1X=2.*XSR*(AP(3)/Q1U-R2/Q1D)
+      Q1XDX=Q1X/XSR+4.*XSR*XSR*((R2/Q1D)*(R2/Q1D)-(AP(3)/Q1U)*(AP(3)/Q1U))
       Q1DX=Q1*Q1X
       Q1DXX=Q1DX*Q1X+Q1*Q1XDX
 ! New quantum factor, in order to suppress CVSCR at TPT >> 1
-      if (TPT.lt.6d0/PX) then
+      if (TPT.lt.6./PX) then
          Y0=(PX*TPT)*(PX*TPT)
          Y0DX=Y0/XSR
-         Y0DG=2d0*Y0/GAMI
-         Y0DXX=0d0
+         Y0DG=2.*Y0/GAMI
+         Y0DXX=0.
          Y0DGG=Y0DG/GAMI
          Y0DXG=Y0DG/XSR
          Y1=exp(Y0)
@@ -1125,10 +824,10 @@
          EM2Y1=EM2/(Y1*Y1*SB)
          SUPBDX=EM2Y1*Y1DX
          SUPBDG=EM2Y1*Y1DG
-         SUPBDXX=EM2Y1*(Y1DXX-2d0*Y1DX*Y1DX/Y1-Y1DX*SUPBDX)
-         SUPBDGG=EM2Y1*(Y1DGG-2d0*Y1DG*Y1DG/Y1-Y1DG*SUPBDG)
-         SUPBDXG=EM2Y1*(Y1DXG-2d0*Y1DX*Y1DG/Y1-Y1DG*SUPBDX)
-         SUP=sqrt(SUPA/SUPB)
+         SUPBDXX=EM2Y1*(Y1DXX-2.*Y1DX*Y1DX/Y1-Y1DX*SUPBDX)
+         SUPBDGG=EM2Y1*(Y1DGG-2.*Y1DG*Y1DG/Y1-Y1DG*SUPBDG)
+         SUPBDXG=EM2Y1*(Y1DXG-2.*Y1DX*Y1DG/Y1-Y1DG*SUPBDX)
+         SUP=dsqrt(SUPA/SUPB)
          SUPX=0.5d0*(SUPADX/SUPA-SUPBDX/SUPB)
          SUPDX=SUP*SUPX
          SUPG=0.5d0*(SUPADG/SUPA-SUPBDG/SUPB)
@@ -1147,36 +846,36 @@
          SUPDX=0.5d0*PX*TPT/XSR
          SUPDG=PX*TPT/GAMI
          SUPDXX=-0.5d0*SUPDX/XSR
-         SUPDGG=0d0
+         SUPDGG=0.
          SUPDXG=SUPDX/GAMI
       endif
       GR3=pow(GAMI/SUP,R3)
       GR3X=-R3*SUPDX/SUP
       GR3DX=GR3*GR3X
       GR3DXX=GR3DX*GR3X-R3*GR3*(SUPDXX/SUP-(SUPDX/SUP)*(SUPDX/SUP))
-      GR3G=R3*(1d0/GAMI-SUPDG/SUP)
+      GR3G=R3*(1./GAMI-SUPDG/SUP)
       GR3DG=GR3*GR3G
-      GR3DGG=GR3DG*GR3G+GR3*R3*((SUPDG/SUP)*(SUPDG/SUP)-SUPDGG/SUP-1d0/(GAMI*GAMI))
+      GR3DGG=GR3DG*GR3G+GR3*R3*((SUPDG/SUP)*(SUPDG/SUP)-SUPDGG/SUP-1./(GAMI*GAMI))
       GR3DXG=GR3DG*GR3X+GR3*R3*(SUPDX*SUPDG/(SUP*SUP)-SUPDXG/SUP)
-      W=1d0+Q1/GR3
+      W=1.+Q1/GR3
       WDX=Q1DX/GR3-Q1*GR3DX/(GR3*GR3*GR3)
       WDG=-Q1*GR3DG/(GR3*GR3)
-      WDXX=Q1DXX/GR3-(2d0*Q1DX*GR3DX+Q1*(GR3DXX-2d0*GR3DX*GR3DX/GR3))/(GR3*GR3)
-      WDGG=Q1*(2d0*GR3DG*GR3DG/GR3-GR3DGG)/(GR3*GR3)
-      WDXG=-(Q1DX*GR3DG+Q1*(GR3DXG-2d0*GR3DX*GR3DG/GR3))/(GR3*GR3)
+      WDXX=Q1DXX/GR3-(2.*Q1DX*GR3DX+Q1*(GR3DXX-2.*GR3DX*GR3DX/GR3))/(GR3*GR3)
+      WDGG=Q1*(2.*GR3DG*GR3DG/GR3-GR3DGG)/(GR3*GR3)
+      WDXG=-(Q1DX*GR3DG+Q1*(GR3DXG-2.*GR3DX*GR3DG/GR3))/(GR3*GR3)
       FSCR=-GAMI*Finf*W
       FDX=-GAMI*(FinfDX*W+Finf*WDX)
-      FDXX=-GAMI*(FinfDXX*W+2d0*FinfDX*WDX+Finf*WDXX)
+      FDXX=-GAMI*(FinfDXX*W+2.*FinfDX*WDX+Finf*WDXX)
       FDG=-Finf*W-GAMI*Finf*WDG
-      FDGG=-2d0*Finf*WDG-GAMI*Finf*WDGG
+      FDGG=-2.*Finf*WDG-GAMI*Finf*WDGG
       FDXG=-FinfDX*W-Finf*WDX-GAMI*(FinfDX*WDG+Finf*WDXG)
       S_SCR=-GAMI*GAMI*Finf*WDG
       USCR=S_SCR+FSCR
       CVSCR=-GAMI*GAMI*FDGG
-      PSCR=(XSR*FDX+GAMI*FDG)/3d0
-      PDTSCR=GAMI*GAMI*(XSR*Finf*(FinfX*WDG+WDXG)-FDGG)/3d0
-      PDRSCR=(12d0*PSCR+XSR*XSR*FDXX+2d0*XSR*GAMI*FDXG &
-         + GAMI*GAMI*FDGG)/9d0
+      PSCR=(XSR*FDX+GAMI*FDG)/3.
+      PDTSCR=GAMI*GAMI*(XSR*Finf*(FinfX*WDG+WDXG)-FDGG)/3.
+      PDRSCR=(12.*PSCR+XSR*XSR*FDXX+2.*XSR*GAMI*FDXG &
+         + GAMI*GAMI*FDGG)/9.
       return
       end subroutine FSCRsol8
 
@@ -1188,23 +887,16 @@
 ! Output: anharm.free en. Fah=F_{AH}/(N_i kT), internal energy Uah,
 !   pressure Pah=P_{AH}/(n_i kT), specific heat CVah = C_{V,AH}/(N_i k),
 !   PDTah = Pah + d Pah / d ln T, PDRah = Pah + d Pah / d ln\rho
-      type(auto_diff_real_2var_order1), intent(in) :: GAMI,TPT
-      type(auto_diff_real_2var_order1), intent(out) :: Fah,Uah,Pah,CVah,PDTah,PDRah
+      real(dp), intent(in) :: GAMI,TPT
+      real(dp), intent(out) :: Fah,Uah,Pah,CVah,PDTah,PDRah
       integer, parameter :: NM=3
       
       integer :: N
-      real(dp) :: AA(3)
-      type(auto_diff_real_2var_order1) :: CK, TPT2, TPT4, TQ, TK2, SUP
-      type(auto_diff_real_2var_order1) :: CN, SUPGN, ACN, PN
-      type(auto_diff_real_2var_order1) :: B1
-
-      B1 = 0.12d0 ! coeff.at \eta^2/\Gamma at T=0
-
-      ! Farouki & Hamaguchi'93
-      AA(1) = 10.9d0
-      AA(2) = 247.0d0
-      AA(3) = 1.765d5
-
+      real(dp) :: CK, TPT2, TPT4, TQ, TK2, SUP
+      real(dp) :: CN, SUPGN, ACN, PN
+      real(dp), parameter :: AA(NM) = &
+         (/10.9d0,247.0d0,1.765d5/) ! Farouki & Hamaguchi'93
+      real(dp), parameter :: B1 = 0.12d0 ! coeff.at \eta^2/\Gamma at T=0
       
       CK=B1/AA(1) ! fit coefficient
       TPT2=TPT*TPT
@@ -1212,25 +904,25 @@
       TQ=B1*TPT2/GAMI ! quantum dependence
       TK2=CK*TPT2
       SUP=exp(-TK2) ! suppress.factor of class.anharmonicity
-      Fah=0.d0
-      Uah=0.d0
-      Pah=0.d0
-      CVah=0.d0
-      PDTah=0.d0
-      PDRah=0.d0
+      Fah=0.
+      Uah=0.
+      Pah=0.
+      CVah=0.
+      PDTah=0.
+      PDRah=0.
       SUPGN=SUP
       do N=1,NM
-         CN=1d0*N
+         CN=N
          SUPGN=SUPGN/GAMI ! SUP/Gamma^n
          ACN=AA(N)
          Fah=Fah-ACN/CN*SUPGN
-         Uah=Uah+(ACN*(1d0+2d0*TK2/CN))*SUPGN
-         PN=AA(N)/3d0+TK2*AA(N)/CN
+         Uah=Uah+(ACN*(1.+2.*TK2/CN))*SUPGN
+         PN=AA(N)/3.+TK2*AA(N)/CN
          Pah=Pah+PN*SUPGN
-         CVah=CVah+((CN+1d0)*AA(N)+(4d0-2d0/CN)*AA(N)*TK2 &
-            + 4d0*AA(N)*CK*CK/CN*TPT4)*SUPGN
-         PDTah=PDTah+(PN*(1d0+CN+2d0*TK2)-2d0/CN*AA(N)*TK2)*SUPGN
-         PDRah=PDRah+(PN*(1d0-CN/3d0-TK2)+AA(N)/CN*TK2)*SUPGN
+         CVah=CVah+((CN+1.)*AA(N)+(4.-2./CN)*AA(N)*TK2 &
+            + 4.*AA(N)*CK*CK/CN*TPT4)*SUPGN
+         PDTah=PDTah+(PN*(1.+CN+2.*TK2)-2./CN*AA(N)*TK2)*SUPGN
+         PDRah=PDRah+(PN*(1.-CN/3.-TK2)+AA(N)/CN*TK2)*SUPGN
       enddo
       Fah=Fah-TQ
       Uah=Uah-TQ
@@ -1239,68 +931,54 @@
       return
       end subroutine ANHARM8
 
-      subroutine FHARM12(GAMI,TPT, &
+      subroutine FHARM8(GAMI,TPT, &
          Fharm,Uharm,Pharm,CVth,Sharm,PDTharm,PDRharm)
 ! Thermodynamic functions of a harmonic crystal, incl.stat.Coul.lattice
-! 
-!                                                       Version 27.04.12
-! Stems from FHARM8 v.15.02.08
-! Replaced HLfit8 with HLfit12: rearranged output.
+!                                                       Version 15.02.08
+! Stems from FHARM7 v.09.06.07.
+! Replaced FthCHA7 by the more accurate fit HLfit8.
 ! Input: GAMI - ionic Gamma, TPT=T_{p,i}/T
 ! Output: Fharm=F/(N_i T), Uharm=U/(N_i T), Pharm=P/(n_i T),
 ! CVth=C_V/N_i, Sharm=S/N_i
 ! PDTharm = Pharm + d Pharm / d ln T, PDRharm = Pharm + d Pharm/d ln\rho
-      type(auto_diff_real_2var_order1), intent(in) :: GAMI,TPT
-      type(auto_diff_real_2var_order1), intent(out) :: Fharm,Uharm,Pharm,CVth,Sharm,PDTharm,PDRharm
+      real(dp), intent(in) :: GAMI,TPT
+      real(dp), intent(out) :: Fharm,Uharm,Pharm,CVth,Sharm,PDTharm,PDRharm
 
-      type(auto_diff_real_2var_order1) :: Fth,Uth,Sth,U0,E0
-      type(auto_diff_real_2var_order1) :: F,U,U1
+      real(dp) :: Fth,Uth,Sth,U0
       
-      real(dp), parameter :: CM = .895929256d0 ! Madelung
+      real(dp), parameter :: CM = 0.895929256d0 ! Madelung
       
-      call HLfit12(TPT,F,U,CVth,Sth,U1,1)
+      call HLfit8(TPT,Fth,Uth,CVth,Sth,1)
       U0=-CM*GAMI ! perfect lattice
-      E0=1.5d0*U1*TPT ! zero-point energy
-      Uth=U+E0
-      Fth=F+E0
       Uharm=U0+Uth
       Fharm=U0+Fth
       Sharm=Sth
-      Pharm=U0/3d0+Uth/2d0
+      Pharm=U0/3.+Uth/2.
       PDTharm=0.5d0*CVth
       PDRharm=U0/2.25d0+0.75d0*Uth-0.25d0*CVth
       return
-      end subroutine FHARM12
+      end subroutine FHARM8
 
-      subroutine HLfit12(eta,F,U,CV,S,U1,LATTICE)
-!                                                       Version 24.04.12
-! Stems from HLfit8 v.03.12.08;
-!   differences: E0 excluded from  U and F;
-!   U1 and d(CV)/d\ln(T) are added on the output.
+      subroutine HLfit8(eta,F,U,CV,S,LATTICE)
+!                                                       Version 03.12.08
 ! Fit to thermal part of the thermodynamic functions.
-! Baiko, Potekhin, & Yakovlev (2001).
-! Zero-point lattice quantum energy 1.5u_1\eta EXCLUDED (unlike HLfit8).
+! Baiko, Potekhin, & Yakovlev (2001). Stems from HLfit v.20.03.01.
+! Zero-point lattice quantum energy 1.5u_1\eta INCLUDED (unlike HLfit).
 ! Input: eta=Tp/T, LATTICE=1 for bcc, 2 for fcc
-! Output: F and U (normalized to NkT) - due to phonon excitations,
-!   CV and S (normalized to Nk) in the HL model,
-!   U1 - the 1st phonon moment,
-
-      type(auto_diff_real_2var_order1) :: eta ! can be modified, not sure if this is an intended side-effect
-      type(auto_diff_real_2var_order1), intent(out) :: F, U, CV, S, U1
+! Output: F and U (normalized to NkT),
+!   CV and S (normalized to Nk) in the HL model for bcc Coulomb lattice
+      real(dp) :: eta ! can be modified, not sure if this is an intended side-effect
+      real(dp), intent(out) :: F, U, CV, S
       integer, intent(in) :: LATTICE
 
-      real(dp) :: CLM, ALPHA, BETA, GAMMA
+      real(dp) :: CLM, U1, ALPHA, BETA, GAMMA
       real(dp) :: A1, A2, A3, A4, A6, A8
       real(dp) :: B0, B2, B4, B5, B6, B7, B9, B11
       real(dp) :: C9, C11
-      type(auto_diff_real_2var_order1) :: UP, DN, EA, EB, EG, UP1, UP2, DN1, DN2, E0
-      
-      real(dp) :: EPS
-      real(dp) :: TINY
+      real(dp) :: UP, DN, EA, EB, EG, UP1, UP2, DN1, DN2, E0
       
-      EPS=1.d-5
-      TINY=1.d-99
-
+      real(dp), parameter :: EPS=1.d-5
+      real(dp), parameter :: TINY=1.d-99
       if (LATTICE.eq.1) then ! bcc lattice
          CLM=-2.49389d0 ! 3*ln<\omega/\omega_p>
          U1=0.5113875d0
@@ -1327,9 +1005,9 @@
          ALPHA=0.257591d0
          BETA=0.365284d0
          GAMMA=0.9167070d0
-         A1=0.0d0
+         A1=0.0
          A2=0.532535d0
-         A3=0.0d0
+         A3=0.0
          A4=3.76545d-4
          A6=2.63013d-7
          A8=6.6318d-11
@@ -1344,21 +1022,21 @@
       else
          stop 'HLfit: unknown lattice type'
       endif
-      if (eta.gt.1d0/EPS) then ! asymptote of Eq.(13) of BPY'01
-         U=3d0/(C11*eta*eta*eta)
-         F=-U/3d0
-         CV=4d0*U
+      if (eta.gt.1./EPS) then ! asymptote of Eq.(13) of BPY'01
+         U=3./(C11*eta*eta*eta)
+         F=-U/3.
+         CV=4.*U
       else if (eta.lt.EPS) then ! Eq.(17) of BPY'01
          if (eta.lt.TINY) eta = TINY !stop 'HLfit8: eta is too small'
-         F=3d0*log(eta)+CLM-1.5d0*U1*eta+eta*eta/24.d0
-         U=3d0-1.5d0*U1*eta+eta*eta/12d0
-         CV=3d0-eta*eta/12d0
+         F=3.*log(eta)+CLM-1.5d0*U1*eta+eta*eta/24. 
+         U=3.-1.5d0*U1*eta+eta*eta/12.
+         CV=3.-eta*eta/12.
       else
          B9=A6*C9
          B11=A8*C11
 
-         !UP=1d0+A1*eta+A2*eta**2+A3*eta**3+A4*eta**4+A6*eta**6+A8*eta**8
-         UP=1d0+eta*(A1+eta*(A2+eta*(A3+eta*(A4+eta*eta*(A6+eta*eta*A8)))))
+         !UP=1.+A1*eta+A2*eta**2+A3*eta**3+A4*eta**4+A6*eta**6+A8*eta**8
+         UP=1.+eta*(A1+eta*(A2+eta*(A3+eta*(A4+eta*eta*(A6+eta*eta*A8)))))
 
          !DN=B0+B2*eta**2+B4*eta**4+B5*eta**5+B6*eta**6+B7*eta**7+B9*eta**9+B11*eta**11
          DN=B0+eta*eta*(B2+eta*eta*(B4+eta*(B5+eta*(B6+eta*(B7+eta*eta*(B9+eta*eta*B11))))))
